package de.unima.ki.javakurs.tag3.hanoi;

public class Hanoi {
	private int size;

	public Hanoi(int size) {
		this.size = size;
	}

	public void print(Tower a, Tower b, Tower c) {
		System.out.println();
		System.out.println(" " + a.getName() + "   " + b.getName() + "   " + c.getName());
		for (int i = size - 1; i >= 0; i--) {
			String s = "";
			s += brickToString(a.get(i));
			s += " | ";
			s += brickToString(b.get(i));
			s += " | ";
			s += brickToString(c.get(i));
			System.out.println(s);
		}
		System.out.println();
	}

	public String brickToString(Brick brick) {
		String s = "";
		if (brick == null) {
			for (int j = 0; j < size; j++) {
				s += "  ";
			}
		} else {
			for (int j = 0; j < size - brick.getSize(); j++) {
				s += " ";
			}
			s += brick.toString();
			for (int j = 0; j < size - brick.getSize(); j++) {
				s += " ";
			}
		}
		return s;
	}


	public void move(int i, Tower a, Tower b, Tower c) {
		if (i > 0) {
			move(i - 1, a, c, b);
			c.push(a.pop());
			move(i - 1, b, a, c);
		}
		print(a, b ,c);
	}

}
