package de.unima.ki.javakurs.tag3.hanoi;

public class Tower {

	private int height;
	private Brick[] tower;
	private String name;

	public Tower(int size, String name) {
		tower = new Brick[size];
		height = 0;
		this.name = name;
	}

	public void init() {
		for (int i = 0; i < tower.length; i++) {
			tower[i] = new Brick(tower.length - i);
		}
		height = tower.length;
	}

	public void push(Brick b) {
		int i = 0;
		while (tower[i] != null) {
			i++;
			if (i >= tower.length) {
				System.out.println("Tower ist voll");
				return;
			}
		}
		tower[i] = b;
		height++;
	}

	public Brick pop() {
		int i = tower.length - 1;
		while (tower[i] == null) {
			i--;
			if (i < 0) {
				return null;
			}
		}
		Brick b = tower[i];
		tower[i] = null;
		height--;
		return b;
	}

	public Brick top() {
		int i = tower.length - 1;
		while (tower[i] == null) {
			i--;
			if (i < 0) {
				return null;
			}
		}
		return tower[i];
	}

	public int topSize() {
		if (top() == null) {
			return 0;
		} else {
			return top().getSize();
		}
	}

	public int getHeight() {
		return height;
	}

	public Brick get(int position) {
		return tower[position];
	}
	
	public String getName(){
		return name;
	}

}
