package de.unima.ki.javakurs.tag4.poker;

public class Card implements Comparable<Card> {

	private int color;
	private int value;
	
	/**
	* Constructs a card. 
	* 
	* @param color An int value that refers to an internal id of the color. 
	* @param value An int value that refers to an internal id of the value. 
	*/
	public Card(int color, int value) {
		this.color = color;
		this.value = value;
	}
	
	/**
	* HINT: Check the Comparable interface documentation to understand what
	* this is about and for what purpose it can be used
	*/
	public int compareTo(Card that) {
		if (this.value < that.value) {
			return -1;
		}
		else if (this.value == that.value) {
			if (this.color < that.color) {
				return -1;
			}
			else if (this.color == that.color) {
				return 0;
			}
			else {
				return 1;
			}	
		}
		else {
			return 1;
		}		
	}
	
	/**
	* Returns a representation of this card.
	* 
    * @return An string representation of the card like 'Herz 7' or 'Pik Dame'.  
	*/
	public String toString() {
		String rep = "";
		switch (this.color) {
		case 1:
			rep += "Karo ";
			break;
		case 2:  
			rep += "Herz ";
			break;
		case 3:
			rep += "Pik ";
			break;
		case 4:
			rep += "Kreuz ";
			break;
		}
		switch (this.value) {
			case 7:
			case 8:
			case 9:
			case 10:
				rep += this.value;
				break;
			case 11:  
				rep += "Bube";
				break;
			case 12:
				rep += "Dame";
				break;
			case 13:
				rep += "König";
				break;
			case 14:
				rep += "As";
				break;
		}
		return rep;
	}
	
	/**
	* Returns the color of this card.
	* 
	* @return An int value that refers to an internal id of the color. 
	*/
	public int getColor() {
		return color;
	}

	/**
	* Returns the color of this card.
	* 
	* @return An int value that refers to an internal id of the value. 
	*/	
	public int getValue() {
		return value;
	}	
	
}
